/* This is a simple password program that simply removes a user
   in the database....
*/   

#include <stdio.h>
#include <time.h>
#include "radwho.h"
#include <gdbm.h>          /* database header. */

#define NULL ((void *)0)
//extern int gdbm_err;

/* Should just need a Main routine. */
int main(int argc, char *argv[])
{
char *user = argv[1];
int  res;
const char *sent_pw;
char *real_pw, *invalid_pw;
GDBM_FILE dbf;
datum key,username,nextkey;

if ( argc < 1) {
	puts("USAGE: radrmuser username");
	return 1;
}


/* open the datadabse and get my password. */

dbf = gdbm_open(AUTHFILE,512,GDBM_WRCREAT,00600,0);

/* authorize if we have no file to block access. */
if ( dbf == NULL ) { 
	printf("Database file %s refused to open...\n\n",AUTHFILE);
	return 1;
}
username.dptr = (char *)user;
username.dsize= strlen(user);

res = gdbm_delete( dbf, username);

if ( res == 0 ) {
	printf("Data updated: user %s removed.\n\n",user);
} else {
	printf("ERROR: %s did not exist.\n\n",user);
}

/* list all users */
printf("\nCurrent users in the database are:\n");

key=gdbm_firstkey( dbf );
while( key.dptr ) {
/* get the passwords as a test */
	nextkey=gdbm_fetch( dbf, key );
	nextkey.dptr[nextkey.dsize]=0;
	key.dptr[key.dsize]=0;
/* Done with the password code. */
	printf("%s [%d]\n",key.dptr,key.dsize);
	nextkey=gdbm_nextkey( dbf, key );
	free(key);      /* free this entry */
	key=nextkey;
} /* done listing users */

puts("......");

gdbm_close(dbf);  /* MUST close the file */

return 0;  /* success */
}
/* End of the password insertion program */
